/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.service.ae01b;

import com.ejie.ad74a.dao.ae01b.TiposIngresoDao;
import com.ejie.ad74a.model.ae01b.TiposIngreso;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * TiposIngresoServiceImpl generated by UDA, 27-jun-2023 9:31:05.
 * 
 * @author UDA
 */

@Service(value = "tiposIngresoService")
public class TiposIngresoServiceImpl implements TiposIngresoService {

	@Autowired
	private TiposIngresoDao tiposIngresoDao;

	/**
	 * Inserts a single row in the TiposIngreso table.
	 *
	 * @param tiposIngreso TiposIngreso
	 *
	 * @return TiposIngreso
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposIngreso add(TiposIngreso tiposIngreso) {
		if (tiposIngreso != null) {
			tiposIngreso.setUsuAlta30(UtilSeguridad.getUsuarioConectado().getUserName());
			tiposIngreso.setUsuModif30(UtilSeguridad.getUsuarioConectado().getUserName());
			tiposIngreso.setfAlta30(UtilidadesFecha.getFechaSistema());
			tiposIngreso.setfModif30(UtilidadesFecha.getFechaSistema());
		}
		return this.tiposIngresoDao.add(tiposIngreso);
	}

	/**
	 * Updates a single row in the TiposIngreso table.
	 *
	 * @param tiposIngreso TiposIngreso
	 *
	 * @return TiposIngreso
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposIngreso update(TiposIngreso tiposIngreso) {
		if (tiposIngreso != null) {
			tiposIngreso.setUsuModif30(UtilSeguridad.getUsuarioConectado().getUserName());
			tiposIngreso.setfModif30(UtilidadesFecha.getFechaSistema());
		}
		return this.tiposIngresoDao.update(tiposIngreso);
	}

	/**
	 * Finds a single row in the TiposIngreso table.
	 *
	 * @param tiposIngreso TiposIngreso
	 *
	 * @return TiposIngreso
	 */
	public TiposIngreso find(TiposIngreso tiposIngreso) {
		return (TiposIngreso) this.tiposIngresoDao.find(tiposIngreso);
	}

	/**
	 * Deletes a single row in the TiposIngreso table.
	 *
	 * @param tiposIngreso TiposIngreso
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TiposIngreso tiposIngreso) {
		this.tiposIngresoDao.remove(tiposIngreso);
	}

	/**
	 * Finds a list of rows in the TiposIngreso table.
	 *
	 * @param tiposIngreso    TiposIngreso
	 * @param tableRequestDto TableRequestDto
	 *
	 * @return List<TiposIngreso>
	 */
	public List<TiposIngreso> findAll(TiposIngreso tiposIngreso, TableRequestDto tableRequestDto) {
		return (List<TiposIngreso>) this.tiposIngresoDao.findAll(tiposIngreso, tableRequestDto);
	}

	/**
	 * Finds rows in the TiposIngreso table using like.
	 *
	 * @param tiposIngreso    TiposIngreso
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * 
	 * @return List<TiposIngreso>
	 */
	public List<TiposIngreso> findAllLike(TiposIngreso tiposIngreso, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<TiposIngreso>) this.tiposIngresoDao.findAllLike(tiposIngreso, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposIngreso table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.tiposIngresoDao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the TiposIngreso table.
	 *
	 * @param filterTiposIngreso TiposIngreso
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 *
	 * @return TableResponseDto<TiposIngreso>
	 */
	public TableResponseDto<TiposIngreso> filter(TiposIngreso filterTiposIngreso, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<TiposIngreso> listaTiposIngreso = this.tiposIngresoDao.findAllLike(filterTiposIngreso, tableRequestDto,
				false);
		Long recordNum = this.tiposIngresoDao
				.findAllLikeCount(filterTiposIngreso != null ? filterTiposIngreso : new TiposIngreso(), false);
		TableResponseDto<TiposIngreso> tableResponseDto = new TableResponseDto<TiposIngreso>(tableRequestDto, recordNum,
				listaTiposIngreso);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null
				&& !tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			List<TableRowDto<TiposIngreso>> reorderSelection = this.tiposIngresoDao.reorderSelection(filterTiposIngreso,
					tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<TiposIngreso>> reorderSeeker = this.tiposIngresoDao.reorderSelection(filterTiposIngreso,
					tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * Searches rows in the TiposIngreso table.
	 *
	 * @param filterTiposIngreso TiposIngreso
	 * @param searchTiposIngreso TiposIngreso
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 *
	 * @return List<TableRowDto<TiposIngreso>>
	 */
	public List<TableRowDto<TiposIngreso>> search(TiposIngreso filterTiposIngreso, TiposIngreso searchTiposIngreso,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.tiposIngresoDao.search(filterTiposIngreso, searchTiposIngreso, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in TiposIngreso table.
	 *
	 * @param filterTiposIngreso TiposIngreso
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 *
	 * @return Object
	 */
	public Object reorderSelection(TiposIngreso filterTiposIngreso, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.tiposIngresoDao.reorderSelection(filterTiposIngreso, tableRequestDto, startsWith);
	}

	@Transactional(rollbackFor = Throwable.class)
	public List<TiposIngreso> getMultiple(TiposIngreso filterTiposIngreso, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.tiposIngresoDao.getMultiple(filterTiposIngreso, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterTiposIngreso TiposIngreso
	 * @param columns            String[]
	 * @param columnsName        String[]
	 * @param fileName           String
	 * @param sheetTitle         String
	 * @param reportsParams      ArrayList<?>
	 * @param tableRequestDto    TableRequestDto
	 * @param request            HttpServletRequest
	 * @param response           HttpServletResponse
	 */
	@Override
	public void generateReport(TiposIngreso filterTiposIngreso, String[] columns, String[] columnsName, String fileName,
			String sheetTitle, ArrayList<?> reportsParams, TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<TiposIngreso> filteredData = getDataForReports(filterTiposIngreso, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle : TiposIngreso.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = TiposIngreso.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					TiposIngreso.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// Si no se definen los nombres de las columnas se dejan las definidas por
		// defecto
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TiposIngreso>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<TiposIngreso> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(columnsName[i]);
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (TiposIngreso rowTiposIngreso : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellTiposIngreso = row.createCell(cellNumber++);
					cellTiposIngreso.setCellValue(getCellValue(column, rowTiposIngreso));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TiposIngreso>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<TiposIngreso> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (TiposIngreso rowTiposIngreso : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowTiposIngreso));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TiposIngreso>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<TiposIngreso> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (TiposIngreso rowTiposIngreso : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowTiposIngreso));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TiposIngreso>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<TiposIngreso> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (TiposIngreso rowTiposIngreso : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowTiposIngreso);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterTiposIngreso TiposIngreso
	 * @param tableRequestDto    TableRequestDto
	 *
	 * @return List<TiposIngreso>
	 */
	public List<TiposIngreso> getDataForReports(TiposIngreso filterTiposIngreso, TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterTiposIngreso != null) {
				return this.tiposIngresoDao.findAllLike(filterTiposIngreso, tableRequestDto, false);
			} else {
				return this.tiposIngresoDao.findAll(new TiposIngreso(), null);
			}
		} else {
			return this.tiposIngresoDao.getMultiple(filterTiposIngreso, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column          String
	 * @param rowTiposIngreso TiposIngreso
	 *
	 * @return String
	 */
	private String getCellValue(String column, TiposIngreso rowTiposIngreso) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowTiposIngreso, column) != null
					? BeanUtils.getProperty(rowTiposIngreso, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}
}
